add wrt and fai server setup scripts
[automated-distro-installer] / arch-init
1 #!/bin/bash -x
2
3 # see t.org for how to call
4
5 set -eE -o pipefail
6 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
7
8 cd $(dirname $(readlink -f "$BASH_SOURCE"))
9
10 export ROOTPW="$1"
11 export hostname="$2"
12 mirror=$3
13
14 (( $# >= 2 )) || { echo "error: need 2 arguments"; exit 1; }
15
16 case $hostname in
17 x2)
18 export grubdisk=/dev/sda
19 ;;
20 demohost)
21 export grubdisk=/dev/vda
22 ;;
23 treetowl)
24 bootid=64d495ee-c9fe-4174-b20a-6c5e47abcfa1
25 export grubdisk=$(blkid|sed -nr "/$bootid/s/^([^0-9]+).*/\1/p")
26 ;;
27 frodo)
28 rootid=e9ce7b46-9a21-4e79-b7f7-0b18acb57587
29 export grubdisk=$(blkid|sed -nr "/$rootid/s/(^[^0-9]*).*/\1/p")
30 ;;
31 *)
32 echo "unrecognized hostname: $hostname"
33 exit 1
34 esac
35
36
37 rm -f /etc/pacman.d/mirrorlist
38 # https://wiki.archlinux.org/index.php/Mirrors#Sorting_mirrors
39
40 if [[ $mirror ]]; then
41 echo "Server = $mirror" >> /etc/pacman.d/mirrorlist
42 fi
43 curl -s 'https://www.archlinux.org/mirrorlist/?country=US&protocol=https&ip_version=4&ip_version=6&use_mirror_status=on' |
44 sed -r 's/^[ #]*(Server *=)/\1/' >> /etc/pacman.d/mirrorlist
45
46 ifclass() {
47 local var=${1/#/CLASS_}
48 [[ $hostname == $1 || ${!var} ]]
49 }
50 export -f ifclass
51 for x in $(bash 50-host-classes); do
52 export CLASS_$x=true
53 done
54
55 export LUKS_DIR=/root/luks
56 export HOSTNAME=$hostname
57 chmod +x partition.DEFAULT
58 ./partition.DEFAULT
59 # arch doesn't need crypttab entries for initramfs crypt partititions
60 sed -ri '/^crypt_dev/d' /tmp/fai/crypttab
61 mount -o subvol=/root /dev/mapper/crypt_dev_?da3 /mnt
62 mkdir -p /mnt/{q,home}
63 mount -o subvol=/q /dev/mapper/crypt_dev_?da3 /mnt/q
64 mount -o subvol=/home /dev/mapper/crypt_dev_?da3 /mnt/home
65 mkdir -p /mnt/etc
66 cp /tmp/fai/{fstab,crypttab} /mnt/etc
67 mkdir -p /mnt/boot
68 mount /dev/?da1 /mnt/boot
69
70 # https://wiki.archlinux.org/index.php/Dm-crypt/Device_encryption#Keyfiles
71 cp /root/luks/host-$hostname /mnt/crypto_keyfile.bin
72 chmod 600 /mnt/crypto_keyfile.bin
73
74
75 shopt -s extglob
76 case $hostname in
77 # these hosts are broken, not updated to new fai hyrbrid scripts.
78 frodo)
79
80 # for this system, no separate /boot, to keep partitions simple,
81 # since we want simpler backup recovery.
82 mount -U $rootid /mnt
83 ;;&
84 treetowl)
85 mount /dev/mapper/vg_treetowl00-lv02 /mnt
86 mount -U $bootid /mnt/boot
87 ;;&
88 frodo|treetowl)
89 rm -rf /mnt/!(a|i|q|f|boot) /mnt/boot/*
90 ;;
91 esac
92
93
94
95 if [[ $mirror ]]; then
96 echo "$0: 404 errors about core.db etc are normal,
97 they will succeed using the secodary mirror"
98 fi
99 pacstrap /mnt base
100 case $hostname in
101 frodo)
102 # the root .ssh needs to be like this,
103 # because it\'s used to get the key to mount an encrypted filesystem
104 # on top of itself.
105 d=/mnt/q/root/.ssh
106 rm -rf $d # for idempotency
107 mkdir -p $d
108 scp -oStrictHostKeyChecking=no ian@treetowl:/a/c/machine_specific/frodo/subdir_files/.ssh/* $d
109 cp .ssh/* $d
110 ln -s /q/root/.ssh /mnt/root
111 # background: errors=remount-ro is a debian installer thing. seems like
112 # not a bad idea. man mount says: The default is set in the filesystem
113 # superblock, and can be changed using tune2fs(8)
114
115 cat > /mnt/etc/fstab <<'EOF'
116 UUID=e9ce7b46-9a21-4e79-b7f7-0b18acb57587 / ext4 noatime,errors=remount-ro 0 1
117 UUID=dd67766f-93c5-4ce3-9877-a1d9841dd4a4 none swap sw 0 0
118 /dev/sr0 /media/cdrom0 udf,iso9660 user,noauto 0 0
119 /dev/mapper/crypta7 /mnt/btrfs_root btrfs subvolid=0,noatime,noauto 0 2
120 /dev/mapper/crypta7 /a btrfs subvol=a,noatime,noauto 0 2
121 EOF
122 ;;
123 *)
124 genfstab -p /mnt > /mnt/etc/fstab
125 cp -r .ssh /mnt/root
126 cp -r /root/distro-install-common /mnt/root
127 ;;&
128 treetowl)
129 echo "UUID=a9e83bb7-d23d-4de6-ba9f-d88b887f7206 /a ext4 noatime 0 2" >> /mnt/etc/fstab
130 ;;
131 esac
132
133 cp /root/arch-init-chroot /mnt/root
134 # for manual commands, arch-chroot /mnt bash
135 arch-chroot /mnt /root/arch-init-chroot
136
137 # this gets mounted in chroot so we have to do it outside
138 rm -f /mnt/etc/resolv.conf
139 ln -s /run/systemd/resolve/resolv.conf /mnt/etc/resolv.conf
140
141 # not necsesary, but makes reboot go fast.
142 umount -R /mnt
143
144 # causes 255 exit code, so doing this from the caller script.
145 # reboot now